*	Watching this routine magically rouse FoxPro into life can cause
*	great ammusement for FoxPro developers - impress your collegues.
*
*	One problem is that detection of the launched application being
*	terminated is by monitoring the number of current tasks running under 
*	windows - when this reduces FoxPro is resumed. Ideally the launched
*	application's task terminating would be directly monitored. Under 
*	FoxPro this is very difficult as the current task reported will always
*	be FoxPro - what would be ideal is for a windows API expert to alter
*	this to monitor the launched task specifically and mail this function
*	back to me. In the mean time this is a great simple solution to the
*	problem of launching other windows applications from within FoxPro.
*
*	Feel free to use and improve this useful routine - just mail me any
*	significant improvements      - Thanks Brian.

*:********************************************************
* Minimizes the current FoxPro Application,
* runs a windows program, allows timeout and
* detects forced window maximization.
* Author - Brian M Smith 100345,355
* Last Updated - 09/11/94
* PARAMTERS:	<app2run> = name of a valid windows program
*				<timeout> = seconds to timeout is activated (0 = indefinite)
*				<maxmsg> = message text displayed on timeout OR forced maximize (empty for no message)
*				<maxtitle> = message title displayed on timeout OR forced maximize
* RETURNS:	.F. if normal or timeout occurs,
*			.T. if forced maximization occurs.
* EXAMPLE CALLS:
* #1		? foxwait('NOTEPAD.EXE',5,'Maximize ?','FoxPro') && ie. 5 second timeout
* #2		? foxwait('NOTEPAD.EXE',0,'Maximize ?','FoxPro') && ie. indefinite timeout
* #3		? foxwait('NOTEPAD.EXE',-1,'Please Close Notepad First','FoxPro') && ie. indefinite timeout with forced minimise
* #4		? foxwait('NOTEPAD.EXE',-1,'','') && ie. indefinite timeout with no user maximize
*:********************************************************
FUNCTION foxwait
PARAMETERS app2run, timeout, maxmsg, maxtitle
PRIVATE ALL
	IF NOT 'FOXTOOLS' $ SET('LIBRARY')
		SET LIBRARY TO SYS(2004)+"FOXTOOLS.FLL" ADDITIVE
		m.loadtool = .T.
	ELSE
		m.loadtool = .F.
	ENDIF
	maxforced = .F.
	gettasks = regfn("GETNUMTASKS", "", "I", "KRNL386.EXE")
	starttask = SECONDS()
	ZOOM WINDOW SCREEN MIN
	RUN /N &app2run
	numtasks = callfn(gettasks)
	DO WHILE callfn(gettasks) >= numtasks
		IF timeout <= 0
			starttask = SECONDS()+10
		ENDIF	
		IF timeout = -1
			m.msgbutton = 48
		ELSE
			m.msgbutton = 52
		ENDIF		
		IF SECONDS() > (starttask+timeout) OR NOT WMINIMUM('SCREEN')
			IF EMPTY(maxmsg)
				ZOOM WINDOW SCREEN MIN
				starttask = SECONDS()
			ELSE
				IF msgbox(maxmsg,maxtitle,m.msgbutton) = 6
					maxforced = .T.
					EXIT
				ELSE
					ZOOM WINDOW SCREEN MIN
					starttask = SECONDS()
				ENDIF
			ENDIF	
		ENDIF			
	ENDDO
	IF m.loadtool
		RELEASE LIBRARY SYS(2004)+"FOXTOOLS.FLL"
	ENDIF	
	ZOOM WINDOW SCREEN MAX
RETURN maxforced